
var canvas;
var gl;

var points = [];

var face1 = [
    vec3(-0.5, -0.5 , 0.5),
    vec3(-0.5, 0.5, 0.5),
    vec3(0.5, 0.5, 0.5),
    vec3(0.5, -0.5, 0.5)
];

var face2 = [
    vec3(-0.5, -0.5, -0.5),
    vec3(-0.5, 0.5, -0.5),
    vec3(0.5, 0.5, -0.5),
    vec3(0.5, -0.5, -0.5)
];

var face3 = [
    vec3(-0.5, -0.5, -0.5),
    vec3(-0.5, 0.5, -0.5),
    vec3(-0.5, 0.5, 0.5),
    vec3(-0.5, -0.5, 0.5)
];

var face4 = [
    vec3(0.5, -0.5, 0.5),
    vec3(0.5, 0.5, 0.5),
    vec3(0.5, 0.5, -0.5),
    vec3(0.5, -0.5, -0.5)
];

var face5 = [
    vec3(-0.5, 0.5, -0.5),
    vec3(0.5, 0.5, -0.5),
    vec3(0.5, 0.5, 0.5),
    vec3(-0.5, 0.5, 0.5)
];

var face6 = [
    vec3(-0.5, -0.5, 0.5),
    vec3(-0.5, -0.5, -0.5),
    vec3(0.5, -0.5, -0.5),
    vec3(0.5, -0.5, 0.5)
];

window.onload = function init()
{
    canvas = document.getElementById( "gl-canvas" );
    
    gl = WebGLUtils.setupWebGL( canvas );
    if ( !gl ) { alert( "WebGL isn't available" ); }

    //
    //  Configure WebGL
    //
    gl.viewport( 0, 0, canvas.width, canvas.height );
    gl.clearColor( 1.0, 1.0, 1.0, 1.0 );

    var pMatrix = ortho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);

    // enable hidden-surface removal

    gl.enable(gl.DEPTH_TEST);

    gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

    //  Load shaders 
    
    var program = initShaders( gl, "vertex-shader", "fragment-shader" );
    gl.useProgram( program );

    // locate vPosition in the shaders
    var vPositionLoc = gl.getAttribLocation(program, "vPosition");

    // divide square
    square(face1[0], face1[1], face1[2], face1[3]);
	square(face2[0], face2[1], face2[2], face2[3]);
	square(face3[0], face3[1], face3[2], face3[3]);
	square(face4[0], face4[1], face4[2], face4[3]);
	square(face5[0], face5[1], face5[2], face5[3]);
	square(face6[0], face6[1], face6[2], face6[3]);

    // Load the data into the GPU
    var bufferId = gl.createBuffer();
    gl.bindBuffer( gl.ARRAY_BUFFER, bufferId );
    gl.bufferData( gl.ARRAY_BUFFER, flatten(points), gl.STATIC_DRAW );
    
    // Now render

    gl.enableVertexAttribArray(vPositionLoc);  // activate vertex array for vPosition1

    //    gl.bindBuffer(gl.ARRAY_BUFFER, bufferId); // select buffer to be used
    // The previous line is not necessary because the correct buffer is already selected

    gl.vertexAttribPointer(vPositionLoc, 3, gl.FLOAT, false, 0, 0);  // define data format

    // send projection matrix to shaders
    var pMatrix = ortho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
    var projectionLoc = gl.getUniformLocation(program, "projection");
    gl.uniformMatrix4fv(projectionLoc, false, flatten(pMatrix));

    var ColorLoc = gl.getUniformLocation(program, "Color");

    gl.uniform4fv(ColorLoc, flatten([1.0, 0.0, 0.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, 0, points.length/6);
	
    gl.uniform4fv(ColorLoc, flatten([0.0, 1.0, 0.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, points.length/6, points.length/6);
	
    gl.uniform4fv(ColorLoc, flatten([0.0, 0.0, 1.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, 2*points.length/6, points.length/6);
	
    gl.uniform4fv(ColorLoc, flatten([1.0, 1.0, 0.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, 3*points.length/6, points.length/6);
	
    gl.uniform4fv(ColorLoc, flatten([.0, 1.0, 1.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, 4*points.length/6, points.length/6);
	
    gl.uniform4fv(ColorLoc, flatten([1.0, 0.0, 1.0, 1.0]));
    gl.drawArrays(gl.TRIANGLES, 5*points.length/6, points.length/6);
	


};

function square( a, b, c, d )
{
    points.push( a, b, c);
    points.push( a, c, d);
}




